<template>
  <div>
    <div class="gameStatus" :class="gameStatusColor">
      {{ gameStatusMessage }}
    </div>
    <table class="grid">
      <tr>
        <cell name="1"></cell>
        <cell name="2"></cell>
        <cell name="3"></cell>
      </tr>
      <tr>
        <cell name="4"></cell>
        <cell name="5"></cell>
        <cell name="6"></cell>
      </tr>
      <tr>
        <cell name="7"></cell>
        <cell name="8"></cell>
        <cell name="9"></cell>
      </tr>
    </table>
  </div>

</template>

<script>
  import Cell from './Cell'

  export default {
    name: 'Board',

    components: {
      Cell
    },

    created () {
      this.$bus.$on('go', (cellNumber) => {
        // устанавливает X, либо O в массиве cells
        this.cells[cellNumber] = this.activePlayer

        // увеличиваем количество ходов
        this.moves++

        // сохраняем статус игры, вызывая метод changeGameStatus
        this.gameStatus = this.changeGameStatus()

        if(this.gameStatus!=='win') this.changePlayer()
      })
      // Прослушивает кнопку перезапуска
      // Нажмите для повторной инициализации
      // Вызывается компонентом App
      this.$bus.$on('gridReset', () => {
        Object.assign(this.$data, this.$options.data())
      })
    },

    computed: {
      // неактивный игрок
      nonActivePlayer () {
        if (this.activePlayer === 'O') {
          return 'X'
        }
        return 'O'
      },
      gameStatusMessage () {
        switch (this.gameStatus){
          case 'win': return `${this.activePlayer} Победил !`
          case 'draw': return 'Ничья!'
          default: return `Ход ${this.activePlayer}`
        }
      },
      // цвет статуса используется в качестве цвета фона в строке состояния.
      // он может содержать имя любого из следующих CSS классов
      // StatusTurn (по умолчанию) - желтый во время игры
      // statusWin - зеленый при победе
      // statusDraw - фиолетовый при ничьей
      gameStatusColor () {
        switch (this.gameStatus){
          case 'win': return 'statusWin'
          case 'draw': return 'statusDraw'
          default: return 'statusTurn'
        }
      },
    },

    data () {
      return {
        // может быть O или X
        activePlayer: 'O',
        // отображает статус игры: игра идет, победа или ничья
        gameStatus: 'continue',

        // количество ходов, сделанных игроками (max = 9)
        moves: 0,
        // сохраняет размещение X и O в ячейках по номеру их ячейки
        cells: {
          1: '', 2: '', 3: '',
          4: '', 5: '', 6: '',
          7: '', 8: '', 9: ''
        },
        // Содержит все (8) возможных условий победы
        winConditions: [
          [1, 2, 3], [4, 5, 6], [7, 8, 9], // строки
          [1, 4, 7], [2, 5, 8], [3, 6, 9], // столбцы
          [1, 5, 9], [3, 5, 7]             // диагонали
        ],
      }
    },

    methods: {
      changePlayer () {
        this.activePlayer = this.nonActivePlayer
      },

      changeGameStatus () {
        if (this.checkForWin()) {
          return this.gameIsWon()
          // проверяет, была ли победа в игре и есть ли свободные ячейки
        } else if (this.moves === 9) {
          // устанавливаем статус «draw»
          return 'draw'
        }
        // устанавливаем статус «Игра идет»
        return 'continue'
      },

      checkForWin () {
        for (let i = 0; i < this.winConditions.length; i++) {
          // Получает единственное wc-условие из всего массива
          let wc = this.winConditions[i]
          let cells = this.cells

          // Сравнивает 3 значения ячеек с условием
          if (this.areEqual(cells[wc[0]], cells[wc[1]], cells[wc[2]])) {
            return true
          }
        }
        return false
      },

      areEqual () {
        var len = arguments.length;

        // Проходит через каждое значение и сравнивает их с пустой строкой и на неравенство
        for (var i = 1; i < len; i++){
          if (arguments[i] === '' || arguments[i] !== arguments[i-1])
            return false;
        }
        return true;
      },

      gameIsWon () {
        // Срабатывает событие win для компонента App, чтобы изменить оценку
        this.$bus.$emit('win', this.activePlayer)

        // Запускает событие для блокировки ячейки
        this.$bus.$emit('freeze')

        // Установить статус win
        return 'win'
      }
    },
  }
</script>

<style>
  .grid {
    background-color: #34495e;
    color: #fff;
    width: 100%;
    border-collapse: collapse;
  }
  .gameStatus {
    margin: 0px;
    padding: 15px;
    border-top-left-radius: 20px;
    border-top-right-radius: 20px;
    background-color: #f1c40f;
    color: #fff;
    font-size: 1.4em;
    font-weight: bold;
  }
  .statusTurn {
    background-color: #f1c40f;
  }
  .statusWin {
    background-color: #2ecc71;
  }
  .statusDraw {
    background-color: #9b59b6;
  }
</style>